#include <sstream>
#include "driver.h"
#include "parser.tab.hh"
//#include "errors.h"

//vhdl_driver::vhdl_driver (std::vhdl_symtable * sym_table, std::vhdl_file_list * filelist)
vhdl_driver::vhdl_driver ()
{
	identifier.erase();
//	symtable = sym_table;
//	file_list = filelist;
//	next_token_is_macro = false;
	p_symtable = new std::symtable();
}

vhdl_driver::~vhdl_driver ()
{
	delete(p_symtable);
}

void
vhdl_driver::parse (const std::string &f)
{
  file = f;
//  file_index = file_list->addFile(file);
  scan_begin ();
  yy::vhdl_parser parser (*this);
  parser.set_debug_level(1);		// zapnout ladicí výpisy
  parser.parse ();
  scan_end ();
}

void
vhdl_driver::error (const yy::location& line, const std::string& message)
{
  std::cerr << line << ": " << message << std::endl;
}

void
vhdl_driver::error (const std::string& message)
{
  std::cerr << message << std::endl;
}






// /*
//  * Zkonvertuje \u a \U escape sekvenci na odpovídající tvar ve vnitřním kódování
//  */
// //TODO Převod je řešen naivně a zřejmě neodpovídá normě. Bude to asi potřeba nějak překódovat.
// void vhdl_driver::identifierAddUCN(char * yytext, int number) {
// 	int num = 0;
// 	int digit;
// 	//TODO zde chybí testování povolených a nepovolených hodnot
// 	for(int i = 2; i <= number; i++) {
// 		digit = static_cast<int>(yytext[i]);
// 		digit = (digit > 57) ? digit - 55 : digit - ZERO_OFFSET;
// 		digit = (digit > 15) ? digit - 32 : digit;
// 		num << 4;
// 		num += digit;
// 	}
// 	std::ostringstream ostr(identifier, std::ios::ate);
// 	ostr << num;
// 	identifier = ostr.str();
// }
//
// void vhdl_driver::startIdentifier(char * yytext)
// {
// 	identifier.erase();
// 	identifier.append(yytext);
// }
//
// void vhdl_driver::appendIdentifier(char * yytext)
// {
// 	identifier.append(yytext);
// }
//
// void vhdl_driver::finishIdentifier()
// {
// 	// TODO Tady by pak mělo být něco užitečného pro zpracování toho identifikátoru
// }

// std::string vhdl_driver::filename()
// {
// 	return file;
// }

// void vhdl_driver::set_filename(std::string filename)
// {
// 	file = filename;
// }

// void vhdl_driver::pushandset_filename(std::string filename)
// {
// 	file_index = file_list->addFile(filename);
// 	file_stack_data data;
// 	data.name = filename;
// 	data.index = file_index;
// 	file_stack.push(data);
// 	file = filename;
// }

// void vhdl_driver::pop_filename()
// {
// 	if (!file_stack.empty()) {
// 		file_stack_data data;
// 		data = file_stack.top();
// 		file_stack.pop();
// 		file = data.name;
// 		file_index = data.index;
// 	} else {
// 		std::ostringstream message;
// 		message << "Warning: Internal error " << ERR_CODE_POP_FILE_NAME << ". Things may be wrong.";
// 		error(message.str());
// 	}
// }

// void vhdl_driver::set_scan_buffer(std::string & buffer)
// {
// 	include_stack[include_stack_ptr++] = YY_CURRENT_BUFFER;		// Vložení aktuálního bufferu na zásobník ve flexu
// 	file_stack.push(file);	// Je to potřeba, protože konec bufferu se zpracuje <<EOF>> pravidlem v flexu a to udělá POP
// 	yy_switch_to_buffer(yy_scan_string(buffer.c_str()));		// Vytvoření nového bufferu a přepnutí na něj
// }

// std::string vhdl_driver::get_string()
// {
// 	return my_string;
// }

// void vhdl_driver::nextTokenIsMacro(std::vhdl_macro_data::macro_type macroType)
// {
// 	next_token_is_macro = true;
// 	macro_type = macroType;
// }
//
// bool vhdl_driver::isNextTokenMacro()
// {
// 	return next_token_is_macro?next_token_is_macro = false, true:false;
// }
//
// std::vhdl_macro_data::macro_type vhdl_driver::macroType()
// {
// 	return macro_type;
// }

