#ifndef VHDL_DRIVER_H
#define VHDL_DRIVER_H

#include "parser.tab.hh"
#include <string>
#include <stack>
#include "symtable.h"
//# include <map>
//#include "vhdl_symtable.h"
//#include "vhdl_file_list.h"

# define YY_DECL										\
  yy::vhdl_parser::token_type                         \
  yylex (yy::vhdl_parser::semantic_type* yylval,      \
         yy::vhdl_parser::location_type* yylloc,      \
         vhdl_driver& driver)

//namespace YY {
YY_DECL;
//}


class vhdl_driver
{
public:
	struct file_stack_data {
		std::string name;
		int index;
	};

//	vhdl_driver (std::vhdl_symtable * symtable, std::vhdl_file_list * filelist);
	vhdl_driver ();
	virtual ~vhdl_driver ();

	// Handling the scanner.
	void scan_begin ();
	void scan_end ();
	// Handling the parser.
	void parse (const std::string& f);
	// Error handling.
	void error (const yy::location& l, const std::string& m);
	void error (const std::string& m);
//	std::string filename();

//	void identifierAddUCN(char * yytext, int number);
// 	void startIdentifier(char * yytext);
// 	void appendIdentifier(char * yytext);
// 	void finishIdentifier();

	std::string file;
	int file_index;
	std::symtable * p_symtable;

//	void set_filename(std::string filename);
//	void pushandset_filename(std::string filename);
//	void pop_filename();

//	void nextTokenIsMacro(std::vhdl_macro_data::macro_type macroType);
//	bool isNextTokenMacro();
//	std::vhdl_macro_data::macro_type macroType();


//	std::vhdl_symtable * symtable;

// 	void set_scan_buffer(std::string & buffer);

// 	std::string get_string();

private:
	std::string identifier;
	std::stack<file_stack_data> file_stack;
//	std::vhdl_file_list * file_list;
//	bool next_token_is_macro;
//	std::vhdl_macro_data::macro_type macro_type;
	//std::map<std::string, int> variables;

};


#endif
