#ifndef SYMTABLE_H
#define SYMTABLE_H

#include <set>
#include <string>

/**
	@author Luboš Lorenc <lorenc@fit.vutbr.cz>
*/

namespace std {

class symtable{
public:
	enum sets {s_architecture, s_range, s_unit, s_type, s_subtype, s_function, s_signal, s_variable, s_file, s_generic, s_port, s_parameter, s_element, s_generate_statement};

    symtable();

    ~symtable();


	void addToSet(sets _set, string what);
	void addSetToSet(sets _set, set<string> * what);
	bool isInSet(sets _set, string what);
	int getToken(string str, int fall_back);

private:
	set <string> name_architecture;
	set <string> name_range;		// Tato bude asi pořád prázdná, protože jsem nenašel, kde by se ty rozsahy mohly definovat :-(
	set <string> name_unit;
	set <string> name_type;
	set <string> name_subtype;
	set <string> name_function;
	set <string> name_signal;
	set <string> name_variable;
	set <string> name_generic;
	set <string> name_port;
	set <string> name_parameter;
	set <string> name_file;
	set <string> simple_name_element;
	set <string> label_generate_statement;

	set <string> &getSet(sets _set);
};

}

#endif
